<template>
  <div class="col mb-3 text-end" v-if="becasStore.becas.length > 0">

    <a :href="infomeBecasImprimir(0)
    " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal p-1 px-2 mt-1">
      <i class="fa-solid fa-print me-1"></i> Imprimir PDF Detallado
    </a>
    <a :href="infomeBecasImprimir(1)
    " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal mx-3 p-1 px-2 mt-1">
      <i class="fa-solid fa-print me-1"></i> Imprimir PDF Totales
    </a>
    <a :href="infomeBecasImprimirExel()
    " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal  p-1 px-2 mt-1">
      <i class="fa-solid fa-table me-1"></i> Excel
    </a>
  </div>
  <div class="text-center">
    <table class="table table-striped" v-if="becasStore.becas.length > 0">
      <thead>
        <tr class="bg-princial text-light fs-4 text-uppercase">
          <th scope="col" style="padding: 15px 10px !important">Solicitante</th>
          <th scope="col" style="padding: 15px 10px !important">Becario</th>
          <th scope="col" style="padding: 15px 10px !important">Doc. Becario</th>
          <th scope="col" style="padding: 15px 10px !important">Apoderado</th>
          <th scope="col" style="padding: 15px 10px !important">Doc. Apoderado</th>
          <th scope="col" style="padding: 15px 10px !important">F. Inicio</th>
          <th scope="col" style="padding: 15px 10px !important">F. Fin</th>
          <th scope="col" style="padding: 15px 10px !important">Importe</th>
          <th scope="col" style="padding: 15px 10px !important">Mes Certif.</th>
          <th scope="col" style="padding: 15px 10px !important">Visado</th>
          <th scope="col" style="padding: 15px 10px !important">F. Vencim.</th>
          <th scope="col" style="padding: 15px 10px !important">Expediente</th>
          <th scope="col" style="padding: 15px 10px !important">CBU</th>
          <th scope="col" style="padding: 15px 10px !important">Observaciones</th>
          <th scope="col" style="padding: 15px !important"></th>
        </tr>
      </thead>
      <tbody class="becasConsultaTabla">
        <!--si estado = "B" poner la fila en rojo   -->
        <tr :style="{ 'background-color': becaBaja(beca) }" v-for="beca in becasStore.becas" :key="beca.id_beca">

          <td class="pt-3 pb-3 px-2 ps-3" v-text="beca.apellido_solicitante + ' ' + beca.nombres_solicitante"></td>
          <td class="pt-3 pb-3 px-2" v-text="beca.apellido_becario + ' ' + beca.nombres_becario"></td>
          <td class="pt-3 pb-3 px-2" v-text="beca.d_t_doc_becario + ' ' + beca.n_doc_becario"></td>
          <td class="pt-3 pb-3 px-2"
            v-text="(beca.apellido_apoderado != null) ? (beca.apellido_apoderado + ' ' + beca.nombres_apoderado) : ''">
          </td>
          <td class="pt-3 pb-3 px-2"
            v-text="(beca.d_t_doc_apoderado != null) ? (beca.d_t_doc_apoderado + ' ' + beca.n_doc_apoderado) : ''"></td>
          <td class="pt-3 pb-3 px-2 text-center" v-text="fechaMostrar(beca.f_ingreso)"></td>
          <td class="pt-3 pb-3 px-2 text-center" v-text="fechaMostrar(beca.f_egreso)"></td>
          <td class="pt-3 pb-3 px-2 text-right" v-text="importeMostrar(beca.importe)"></td>
          <td class="pt-3 pb-3 px-2 text-center" v-text="mesMostrar(beca.mes_certif)"></td>
          <td class="pt-3 pb-3 px-2 text-center" v-text="beca.d_visado"></td>
          <td class="pt-3 pb-3 px-2 text-center" v-text="fechaMostrar(beca.f_vencim_v)"></td>
          <td class="pt-3 pb-3 px-2" v-text="beca.expediente_mostrar"></td>
          <td class="pt-3 pb-3 px-2" v-text="beca.cbu_completo"></td>
          <td class="pt-3 pb-3 px-2" v-text="beca.observaciones"></td>
          <td class="pt-3 pb-3 px-2 text-center">
            <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mx-1" alt="Ver beca" title="Ver beca"
              @click="abrirABM(beca)">
              <i class="bi bi-search"></i>
            </button>
          </td>
        </tr>
      </tbody>
      <tfoot>
        <tr class="bg-princial text-light fs-5 text-uppercase text-center">
          <th scope="col text-center" style="padding: 7px !important" v-text='"TOTALES:"'></th>
          <th scope="col text-center" style="padding: 7px !important" colspan="4"></th>
          <th scope="col text-center" style="padding: 7px !important" v-text='"IMPORTE:"'></th>
          <th scope="col text-center" style="padding: 7px !important" v-text="importeMostrar(totales.totalImporte)"></th>
          <th scope="col text-center" style="padding: 7px !important" colspan="6"></th>
          <th scope="col text-center" style="padding: 7px !important" v-text='"CANT BECAS:"'></th>
          <th scope="col text-center" style="padding: 7px !important" v-text="totales.cantBecas">
          </th>
        </tr>
      </tfoot>
    </table>
    <div v-else class="alert alert-secondary text-center" role="alert">
      No se ha encontrado ninguna beca en el sistema.
    </div>
  </div>
</template>

<script setup lang="ts">
// Librerías
import { resolveDirective, type PropType, type Ref, reactive,watch } from "vue";
import { DateTime } from "luxon";
import type { RouteLocationRaw } from "vue-router";
import { getUrl } from "@/shared.js";
//import router from "@/router";
import { useRouter } from "vue-router";
import { isEmpty, Expediente } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
// Stores
import { useBecasStore } from "@/stores/becas/becas";
// Entidades
import type Beca from "@/entities/becas/Beca";

import type Solicitante from "@/entities/Solicitante";
import type Becario from "@/entities/becas/Becario";
import type Bloque from "@/entities/Bloque";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";
import type Estado from "@/entities/becas/Estado";
import type Visado from "@/entities/Visado";


const router = useRouter();
const becasStore = useBecasStore();

const fechaMostrar = (fecha: string | undefined) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha!).toFormat('dd/MM/yyyy') : null;
const mesMostrar = (mes: number | null) => (mes !== null) ? DateTime.fromObject({ month: mes }, { locale: 'es-AR' }).toFormat('MM (MMMM)') : "";
const importeMostrar = (importe: number) => Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe);

var totales = reactive({
  totalImporte: 0 as number,
  cantBecas: 0 as number,

});

class Parametros {

  solicitante: Solicitante | undefined;
  f_desde!: String | null;
  f_hasta!: String | null;
  becario: Becario | undefined;
  apoderado: Becario | undefined;
  bloque: Bloque | undefined;
  baproSucursal: BaproSucursal | undefined;
  responsable: Solicitante | undefined;
  liquidaciones: Liquidacion | undefined;
  id_expte: Expediente | undefined
  estado!: Estado | null;
  visado: Visado | undefined;
  orden!: String | null;
};
const props = defineProps({
  parametros: {
    type: Object,
    default: {},
    required: true,
  }
});
function infomeBecasImprimir(detallado: number) {
  var queryParams: any = {
    id_tabla_sol: isEmpty(props.parametros.solicitante) ? null : props.parametros.solicitante?.id_tabla_sol,
    id_becario: isEmpty(props.parametros.becario?.id_becario) ? null : props.parametros.becario?.id_becario,
    id_apoderado: isEmpty(props.parametros.apoderado?.id_apoderado) ? null : props.parametros.apoderado?.id_apoderado,
    id_bloque: isEmpty(props.parametros.bloque?.id_dependen) ? null : props.parametros.bloque?.id_dependen,
    f_desde: props.parametros.f_desde,
    f_hasta: props.parametros.f_hasta,
    id_expte: isEmpty(props.parametros.id_expte) ? null : props.parametros.id_expte,
    id_tabla_sol_responsable: isEmpty(props.parametros.responsable?.id_tabla_sol_responsable) ? null : props.parametros.responsable?.id_tabla_sol_responsable,
    baprosuc: isEmpty(props.parametros.baproSucursal) ? null : props.parametros.baproSucursal,
    id_beca: null,
    estado: props.parametros.estado,
    usar_perfil_consulta: 0,
    cond_visado: props.parametros.visado.id_visado,
    orden: props.parametros.orden,
    detallado: detallado,
  }
  return getUrl('infomeBecasImprimir', [], queryParams);

}
function becaBaja(beca: Beca) {
  if (beca.estado == 'B') {
    return "red";
  } else {
    return "white";
  }

}

function infomeBecasImprimirExel() {
  var queryParams: any = {
    id_tabla_sol: isEmpty(props.parametros.solicitante) ? null : props.parametros.solicitante?.id_tabla_sol,
    id_becario: isEmpty(props.parametros.becario?.id_becario) ? null : props.parametros.becario?.id_becario,
    id_apoderado: isEmpty(props.parametros.apoderado?.id_apoderado) ? null : props.parametros.apoderado?.id_apoderado,
    id_bloque: isEmpty(props.parametros.bloque?.id_dependen) ? null : props.parametros.bloque?.id_dependen,
    f_desde: props.parametros.f_desde,
    f_hasta: props.parametros.f_hasta,
    id_expte: isEmpty(props.parametros.id_expte) ? null : props.parametros.id_expte,
    id_tabla_sol_responsable: isEmpty(props.parametros.responsable?.id_tabla_sol_responsable) ? null : props.parametros.responsable?.id_tabla_sol_responsable,
    baprosuc: isEmpty(props.parametros.baproSucursal) ? null : props.parametros.baproSucursal,
    id_beca: null,
    estado: props.parametros.estado,
    usar_perfil_consulta: 0,
    cond_visado: props.parametros.visado.id_visado,
    orden: props.parametros.orden,
  }
  return getUrl('infomeBecasImprimirExel', [], queryParams);

}

function abrirABM(beca: Beca | null = null) {
  const id_beca: number | null = (beca !== null) ? beca.id_beca : null;

  const route: RouteLocationRaw = {
    name: 'inicioInformeBecasDetalle',
    params: {
      id_beca: id_beca,
      id_tabla_sol: null,
      es_abm: 0
    }
  };
  router.push(route);
}

function calcularTotales() {
  var becas = becasStore.becas;
  becas.forEach(element => {
    totales.totalImporte += Math.abs(element.importe);
    totales.cantBecas += 1;
  });
}

watch(() => becasStore.becas, async (newValue: any, oldValue: any) => {
  if (newValue.length > 0) {
    totales.totalImporte=0;
    totales.cantBecas=0;
    calcularTotales();
  }
});

</script>
